use warnings;
use strict;

use encoding 'utf8';
use English qw(-no_match_vars);
use Test::More qw(no_plan);
use XML::Twig;

my @xml_examples = (
    '<Chapter></Chapter>',
    '<Chapter>Bullet:•</Chapter>',
    '<Chapter>hello world.</Chapter>',
    '<Chapter>With entity: &lt;foo&gt; and bullet:•</Chapter>',
    '<Chapter>With entity: &lt; and non-entity: > and bullet:•</Chapter>',
);

my $twig;
for my $keep_encoding ( 0, 1 ) {
    $twig = make_twig( keep_encoding => $keep_encoding );
    for my $xml (@xml_examples) {

        # my $doc = qq{<?xml version="1.0" encoding="utf-8"?>\n$xml};
        my $doc = $xml;
        $twig->parse($doc);
        my $got_from_sprint = $twig->sprint();
        Test::More::is( $got_from_sprint, $doc,
            "keep_encoding  => $keep_encoding ; 1st generation; sprint matched for '$xml'"
        );

        my $second_twig = make_twig( keep_encoding => $keep_encoding );
        $second_twig->parse($got_from_sprint);
        my $got_sprint_from_second_twig = $second_twig->sprint();
        Test::More::is( $got_sprint_from_second_twig, $doc,
            "keep_encoding  => $keep_encoding ; 2nd generation; sprint matched for '$xml'"
        );
    }
}

sub make_twig {
    my %params = @_;

    #    %params = ( output_encoding => 'utf-8', );
    my $twig = XML::Twig->new(%params);
    return $twig;
}
